#!/bin/bash
set -x
WIFI_DEV=$1
WIFI_MOD=iwlwifi

lshw -c network 2>/dev/null | grep -q "driver=${WIFI_MOD}" && {
    sudo modprobe -r ${WIFI_MOD}
    sudo modprobe ${WIFI_MOD}
    sleep 1
}

sudo ifconfig $WIFI_DEV up
#sudo iw dev $WIFI_DEV scan | egrep 'signal|^BSS |WPA|WEP|SSID:|Authentication' | sed -e 's/(/ /g' | awk '{if($0~/^BSS/) {MAC=$2; m[MAC]=MAC; wifi[MAC,"enc"]="unencrypted";} if($0~/SSID/) {ssid=$2; for(i=3; i<=NF; i++) ssid=ssid " " $i; wifi[MAC,"SSID"]=ssid;} if($0~/WPA/ || $0~/WEP/) { wifi[MAC,"enc"]="encrypted";} if($0~/signal/) {wifi[MAC,"sig"]=$2;} if($0~/Auth/) {wifi[MAC,"auth"]=$4;}} END {for (mac in m) { print mac "," wifi[mac,"SSID"] "," wifi[mac,"sig"] "," wifi[mac,"enc"] "," wifi[mac,"auth"];}}'

sudo iwlist $WIFI_DEV scanning \
| egrep 'Cell |Encryption|Quality|ESSID|Authentication' \
| sed -e 's/(/ /g' -e 's/\// /g' -e 's/=/ /g' -e 's/"//g' \
| awk '{if($0~/Cell/) {MAC=$5; m[MAC]=MAC; wifi[MAC,"enc"]="false";} if($0~/ESSID/) {split($0, a, ":"); ssid=a[2]; wifi[MAC,"SSID"]=ssid;} if($0~/Quality/) {wifi[MAC,"sig"]=$2;} if($0~/Encryption/) {split($0, a, ":"); wifi[MAC, "enc"]=(a[2]~/on/);} if($0~/Authentication/) {wifi[MAC,"auth"]=$5;}} END {for (mac in m) { print mac "," wifi[mac,"SSID"] "," wifi[mac,"sig"] "," wifi[mac,"enc"] "," wifi[mac,"auth"];}}'
